From 70fbdbcb0f72c835b4cf91944c841b02e4250701 Mon Sep 17 00:00:00 2001
From: jonas <jonas@fs.ei.tum.de>
Date: Sat, 17 Nov 2007 18:59:54 +0100
Subject: [PATCH] Krusader/KDE4 compile fixes for Qt4/Mac

I ported the last X11 bits to Qt (krusaderapp.{h,cpp}) and made the use of
KWindowSystem::windowInfo conditionaly to Q_WS_X11 (krusader.cpp)
The last bit was a stragne error of qtextstream.h, which faild to compile
due to a mysthery preprocessor definition of 'Status' (krservices.{h,cpp})

diff --git a/krusader_kde4/krusader/krservices.cpp b/krusader_kde4/krusader/krservices.cpp
index 08906f3..4b90503 100644
--- a/krusader_kde4/krusader/krservices.cpp
+++ b/krusader_kde4/krusader/krservices.cpp
@@ -19,6 +19,7 @@
 #include <unistd.h>
 // QT includes
 #include <qdir.h>
+#include <qtextstream.h>
 // KDE includes
 #include <kdebug.h>
 // Krusader includes
diff --git a/krusader_kde4/krusader/krservices.h b/krusader_kde4/krusader/krservices.h
index 3f7198a..3d378b8 100644
--- a/krusader_kde4/krusader/krservices.h
+++ b/krusader_kde4/krusader/krservices.h
@@ -22,7 +22,8 @@
 #include <qstringlist.h>
 #include <qmap.h>
 #include <k3process.h>
-#include <qtextstream.h>
+
+class QTextStream;
 
 /**
   *@author Shie Erlich & Rafi Yanai
diff --git a/krusader_kde4/krusader/krusader.cpp b/krusader_kde4/krusader/krusader.cpp
index 79d30a2..94bbcfb 100644
--- a/krusader_kde4/krusader/krusader.cpp
+++ b/krusader_kde4/krusader/krusader.cpp
@@ -495,7 +495,12 @@ void Krusader::hideEvent ( QHideEvent *e ) {
    if ( actWnd )
       isModalTopWidget = actWnd->isModal();
 
+#ifdef Q_WS_X11
+   // KWindowSystem::windowInfo is only available for X11
    if ( showTrayIcon  && !isModalTopWidget  && KWindowSystem::windowInfo( winId(), NET::WMDesktop ).isOnCurrentDesktop() ) {
+#else
+   if ( showTrayIcon  && !isModalTopWidget ) {
+#endif
       sysTray->show();
       hide(); // needed to make sure krusader is removed from
       // the taskbar when minimizing (system tray issue)
diff --git a/krusader_kde4/krusader/krusaderapp.cpp b/krusader_kde4/krusader/krusaderapp.cpp
index 29feb34..bac514b 100644
--- a/krusader_kde4/krusader/krusaderapp.cpp
+++ b/krusader_kde4/krusader/krusaderapp.cpp
@@ -2,16 +2,10 @@
 
 KrusaderApp::KrusaderApp(): KApplication() {}
 
-bool KrusaderApp::x11EventFilter ( XEvent *e ) {
-		switch (e->type) {
-			case FocusIn:
-				emit windowActive();
-				break;
-			case FocusOut:
-				emit windowInactive();
-				break;
-			
-		}
-		//return false; // event should be processed normally
-		return KApplication::x11EventFilter(e);
-	}
+void KrusaderApp::focusInEvent(QFocusEvent *event) {
+	emit windowActive();
+}
+
+void KrusaderApp::focusOutEvent(QFocusEvent *event) {
+	emit windowInactive();
+}
diff --git a/krusader_kde4/krusader/krusaderapp.h b/krusader_kde4/krusader/krusaderapp.h
index 6b1ce58..e5b633d 100644
--- a/krusader_kde4/krusader/krusaderapp.h
+++ b/krusader_kde4/krusader/krusaderapp.h
@@ -2,14 +2,14 @@
 #define KRUSADERAPP_H
 
 #include <kapplication.h>
-#include "X11/Xlib.h"
 
-// declare a dummy kapplication, just to get the X focusin focusout events
+// declare a dummy kapplication, just to get Qt's focusin focusout events
 class KrusaderApp: public KApplication {
 	Q_OBJECT
 public:
 	KrusaderApp();
-	bool x11EventFilter ( XEvent *e );
+	void focusInEvent(QFocusEvent *event);
+	void focusOutEvent(QFocusEvent *event);
 
 signals:
 	void windowActive();
